/*
 *  photomosaic.js - v1.3.1
 *  A javascript plugin that creates a photomosaic of an image
 *  https://github.com/ritz078/photomosaic.js#readme
 *
 *  Made by Ritesh Kumar
 *  Under MIT License
 */
!function(a){"use-strict";function PhotoMosaic(a){if(!a.image)throw new Error("image options is not passed");if(!a.targetElement)throw new Error("targetElement is not passed in options");this.options=this.extend(this.defaults,a),this.options.image.complete?this.process():this.options.image.onload=this.process.bind(this)}PhotoMosaic.prototype.process=function(){this.options.divX=Math.floor(this.options.width/this.options.tileWidth),this.options.divY=Math.floor(this.options.height/this.options.tileHeight);var a=this.renderImage();this.tileCanvas(a)},PhotoMosaic.prototype.extend=function(a,b){for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c]);return a},PhotoMosaic.prototype.defaults={image:null,tileWidth:5,tileHeight:5,targetElement:null,tileShape:"circle",opacity:1,width:null,height:null},PhotoMosaic.prototype.renderImage=function(){var a=this.options,b=document.createElement("canvas");b.width=a.tileWidth*a.divX,b.height=a.tileHeight*a.divY;var c=b.getContext("2d");return c.drawImage(a.image,0,0,b.width,b.height),c},PhotoMosaic.prototype.getAverageColor=function(a){for(var b=-4,c=5,d=0,e={r:0,g:0,b:0},f=a.length;(b+=4*c)<f;)d++,e.r+=a[b],e.g+=a[b+1],e.b+=a[b+2];return e.r=Math.floor(e.r/d),e.g=Math.floor(e.g/d),e.b=Math.floor(e.b/d),e},PhotoMosaic.prototype.tileCanvas=function(a){var b=document.createElement("canvas"),c=b.width=a.canvas.width;b.height=a.canvas.height;for(var d=b.getContext("2d"),e=this.options,f=a.getImageData(0,0,a.canvas.width,a.canvas.height),g=0;g<e.divY;g++)for(var h=0;h<e.divX;h++){var i=h*e.tileWidth,j=g*e.tileHeight,k=this.getImageData(i,j,c,f),l=this.getAverageColor(k),m="rgba("+l.r+","+l.g+","+l.b+","+this.options.opacity+")";d.fillStyle=m,this.createMosaic(i,j,d)}this.options.targetElement.appendChild(b)},PhotoMosaic.prototype.getImageData=function(a,b,c,d){for(var e=[],f=this.options.tileWidth,g=this.options.tileHeight,h=a;a+f>h;h++)for(var i=4*h,j=b;b+g>j;j++){var k=j*c*4;e.push(d.data[i+k+0],d.data[i+k+1],d.data[i+k+2],d.data[i+k+3])}return e},PhotoMosaic.prototype.createMosaic=function(a,b,c){var d=this.options.tileWidth,e=this.options.tileHeight;if("circle"===this.options.tileShape){var f=a+d/2,g=b+e/2,h=Math.min(d,e)/2;c.beginPath(),c.arc(f,g,h,0,2*Math.PI),c.closePath(),c.fill()}else if("rectangle"===this.options.tileShape){var i=e,j=d;c.beginPath(),c.rect(a,b,j,i),c.closePath(),c.fill()}},a.PhotoMosaic=PhotoMosaic}(window);